;
; Ghost Monitor -  ()    
; Copyright (C) 2005, 2006, 2007 Mihailov Ilia (ghost.nsk@mail.ru)
; All Right Reserved


;  :  


LOOP_COUNT	equ 0x2000
LOOP_WAIT	equ 0x20
	
; command address
SMBGLENB	equ 0x0 ; SMBus global enable
SMBGLSTS	equ 0x1 ; SMBus global status
SMBHADDR	equ 0x2 ; host address register
SMBHCMD		equ 0x3 ; command register for host controller
SMBHDATA0	equ 0x4 ; data 0 register for host controller
SMBHDATA1	equ 0x5 ; data 1 register for host controller

; status flag
SMBHSTS_OKOK	equ 0x00 ; transaction successful
SMBHSTS_NOACK	equ 0x10 ; not acknowledged (no device)
SMBHSTS_DEVERR	equ 0x11 ; device error
SMBHSTS_TIMEOUT	equ 0x18 ; timeout
SMBHSTS_PROTERR	equ 0x19 ; protocol error
SMBHSTS_BUSY	equ 0x1A ; device busy or arbitration lost
SMBHSTS_PECERR	equ 0x1F ; PEC(Packet Error Checking) error
SMBHSTS_ALLERR	equ 0x1F ; all bits of error above
SMBHSTS_ALRM	equ 0x40 ; alarm message received
SMBHSTS_DONE	equ 0x80 ; command completed

; control command number
SMBHCTRL_BYTEW	equ 0x06 ; write byte
SMBHCTRL_BYTER	equ 0x07 ; read byte
SMBHCTRL_WORDW	equ 0x08 ; write word
SMBHCTRL_WORDR	equ 0x09 ; read word

;-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
nf2_readb:
; static int readbyte(int smb_base, int addr, int cmd)
	; In : al - addr, out : al - value

	; u_char dat = 0, saddr = 2*(addr/2) + 1;
	mov	ebx, [smb_slave]
	or	ebx, 1
	
	push	ebx
	push	eax
.top:
	;OUTb((u_short) (smb_base + SMBHADDR), (u_char) saddr); WAIT; WAIT;
	mov	dx, word[smb_base]
	add	dx, SMBHADDR
	mov	al, [esp + 4]
	out	dx, al
	xor	al, al
	out	0xeb, al
	out	0xeb, al
	
	; OUTb((u_short) (smb_base + SMBHCMD), (u_char) cmd); WAIT; WAIT;
	mov	dx, word[smb_base]
	add	dx, SMBHCMD
	mov	al, [esp]
	out	dx, al
	xor	al, al
	out	0xeb, al
	out	0xeb, al
	
	; OUTb((u_short) (smb_base + SMBGLENB), SMBHCTRL_BYTER); WAIT; WAIT;
	mov	dx, word[smb_base]
	add	dx, SMBGLENB
	mov	al, SMBHCTRL_BYTER
	out	dx, al
	xor	al, al
	out	0xeb, al
	out	0xeb, al
	
	; for (i = 0; i < LOOP_WAIT; ++i) WAIT;
	mov	ecx, LOOP_WAIT
@@:	out	0xeb, al
	loop	@b
	
	
	; for (i = 0; i < LOOP_COUNT; ++i) {
		; dat = INb((u_short) (smb_base + SMBGLSTS)); WAIT; WAIT;
		; if (dat == SMBHSTS_BUSY || dat == SMBHSTS_TIMEOUT)
			; goto top;
		; if (dat & (SMBHSTS_DONE | SMBHSTS_ALLERR))
			; break;
	; }
	mov	ecx, LOOP_COUNT
@@:	mov	dx, word[smb_base]
	add	dx, SMBGLSTS
	in	al, dx
	mov	bl, al
	xor	al, al
	out	0xeb, al
	out	0xeb, al
	cmp	bl, SMBHSTS_BUSY
	je	.top
	cmp	bl, SMBHSTS_TIMEOUT
	je	.top
	test	bl, SMBHSTS_DONE or SMBHSTS_ALLERR
	jnz	@f
	loop	@b
@@:
	; if (dat == SMBHSTS_DONE) {
		; dat = INb((u_short) (smb_base + SMBHDATA0)); WAIT; WAIT;
		; return (dat & 0xFF);
	; } else
		; return -1;
	cmp	bl, SMBHSTS_DONE
	jne	@f
	mov	dx, word[smb_base]
	add	dx, SMBHDATA0
	in	al, dx
	push	eax
	xor	al, al
	out	0xeb, al
	out	0xeb, al	
	pop	eax
	movzx	eax, al
	add	esp, 8
	ret	
@@:	add	esp, 8
	mov	al, -1
	ret

;-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
nf2_writeb:
; static int writebyte(int smb_base, int addr, int cmd, int value)
	; In : al - addr, bl - value

	; u_char dat = 0, saddr = 2*(addr/2) + 1;
	mov	ecx, [smb_slave]
	or	ecx, 1
	
	push	ebx
	push	ecx
	push	eax
.top:
	; OUTb((u_short) (smb_base + SMBHADDR), (u_char) saddr); WAIT; WAIT;
	mov	dx, word[smb_base]
	add	dx, SMBHADDR
	mov	al, [esp + 4]
	out	dx, al
	xor	al, al
	out	0xeb, al
	out	0xeb, al
	
	; OUTb((u_short) (smb_base + SMBHCMD), (u_char) cmd); WAIT; WAIT;
	mov	dx, word[smb_base]
	add	dx, SMBHCMD
	mov	al, [esp]
	out	dx, al
	xor	al, al
	out	0xeb, al
	out	0xeb, al

	; OUTb((u_short) (smb_base + SMBHDATA0), (u_char) value); WAIT; WAIT;
	mov	dx, word[smb_base]
	add	dx, SMBHDATA0
	mov	al, [esp + 8]
	out	dx, al
	xor	al, al
	out	0xeb, al
	out	0xeb, al
	
	; OUTb((u_short) (smb_base + SMBGLENB), SMBHCTRL_BYTEW); WAIT; WAIT;
	mov	dx, word[smb_base]
	add	dx, SMBGLENB
	mov	al, SMBHCTRL_BYTEW
	out	dx, al
	xor	al, al
	out	0xeb, al
	out	0xeb, al
	
	; for (i = 0; i < LOOP_WAIT; ++i) WAIT;
	mov	ecx, LOOP_WAIT
@@:	out	0xeb, al
	loop	@b
	
	; for (i = 0; i < LOOP_COUNT; ++i) {
		; dat = INb((u_short) (smb_base + SMBGLSTS)); WAIT; WAIT;
		; if (dat == SMBHSTS_BUSY || dat == SMBHSTS_TIMEOUT)
			; goto top;
		; if (dat & (SMBHSTS_DONE | SMBHSTS_ALLERR))
			; break;
	; }
	mov	ecx, LOOP_COUNT
@@:	mov	dx, word[smb_base]
	add	dx, SMBGLSTS
	in	al, dx
	mov	bl, al
	xor	al, al
	out	0xeb, al
	out	0xeb, al
	cmp	bl, SMBHSTS_BUSY
	je	.top
	cmp	bl, SMBHSTS_TIMEOUT
	je	.top
	test	bl, SMBHSTS_DONE or SMBHSTS_ALLERR
	jnz	@f
	loop	@b
@@:
	; if (dat == SMBHSTS_DONE)
		; return 0;
	; else
		; return -1;
	xor	al, al
	add	esp, 12
	cmp	bl, SMBHSTS_DONE
	je	@f
	mov	al, -1
@@:	ret
